import socket

from rollbot import as_plugin


@as_plugin
def plex(host_cfg: "plex.host", port_cfg: "plex.port"):
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.settimeout(5)
    try:
        s.connect((host_cfg, port_cfg))
        s.shutdown(socket.SHUT_WR)
    except (ConnectionRefusedError, socket.timeout):
        return "I couldn't reach plex within 5 seconds!"
    return "Well, something is running on that port, so it's probably up!"
