import dice

from rollbot import as_plugin, with_help


@as_plugin
def roll(message):
    argstr = message.raw_args
    try:
        rolls = []
        for roll_exp in argstr.split(","):
            roll = dice.roll(roll_exp)
            if not isinstance(roll, int):
                roll = int(roll)
            rolls.append(str(roll))
        return "Rolled {}, got: {}".format(argstr, ", ".join(rolls))
    except Exception as _:
        return "Sorry - dice expression appears malformed. Add more ()'s"


@as_plugin
def rollstats():
    return f"Rolled normal 4d6h3 stats, got: {', '.join(str(int(dice.roll('4d6h3'))) for _ in range(6))}"


@as_plugin
def rollstatsdumb():
    return f"Rolled dumb d20 stats, got: {', '.join(str(int(dice.roll('d20'))) for _ in range(6))}"


@with_help("The !character command generates a DnD character by firing 3 commands into the chat.")
@as_plugin
def character(message, bot):
    if message.raw_args is not None and "d20" in message.raw_args:
        bot.manually_post_message("!rollstatsdumb", message.group_id)
    else:
        bot.manually_post_message("!rollstats", message.group_id)
    bot.manually_post_message("!choice Barbarian Bard Cleric Druid Fighter Monk Paladin Ranger Rogue Sorcerer Warlock Wizard", message.group_id)
    bot.manually_post_message("!npc", message.group_id)
    return None # to prevent extra message
